package com.msl;

import com.google.common.collect.Sets;
import lombok.SneakyThrows;
import org.apache.commons.io.FileUtils;

import java.io.File;
import java.util.Set;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * @author wanglq
 * Date 2024/8/12
 * Time 13:59
 */
public class Test2 {
    public static Pattern dependency = Pattern.compile("<dependency>.+</dependency>");
    public static Pattern version = Pattern.compile("<version>(\\d|\\.|\\w)+</version>");
    public static Set<String> ignore = Sets.newHashSet("trade-service", "msl-parent",
            "swagger-bootstrap-ui-demo","archetype","clx-contract","clx-setting","code-statistics","code-tool","cola","order-service");

    public static void main(String[] args) {
        File file = new File("d:/develop/clx_projects");
        File[] projects = file.listFiles();
        for (File project : projects) {
            String projectName = project.getName();
            if (ignore.contains(projectName)) {
                continue;
            }
            if (projectName.equals("trade")) {
                for (File subProject : project.listFiles()) {
                    doScan(subProject, subProject.getName());
                }
            } else {
                doScan(project, projectName);
            }
        }
    }

    public static void doScan(File file, String projectName) {
        if (file.getPath().contains("msl-parent")) {
            return;
        }
        if (file.isDirectory()) {
            for (File f : file.listFiles()) {
                doScan(f, projectName);
            }
        } else if (file.getName().equals("pom.xml")) {
            checkFileContent(file, projectName);
        }
    }

    @SneakyThrows
    private static void checkFileContent(File file, String projectName) {
        String content = FileUtils.readFileToString(file, "UTF-8");
        content = content.replace("\r\n", "");
//        content = content.replace("<dependencies>", "\r\n<dependencies>");
//        content = content.replace("</dependencies>", "\r\n</dependencies>");
        content = content.replace("<dependency>", "\r\n<dependency>");
        Matcher matcher = dependency.matcher(content);
//        String path = file.getPath();
//        path = path.substring(24);
//        path = path.substring(0, path.indexOf("\\"));
        while (matcher.find()) {
            String group = matcher.group();
            if (group.contains("version") && !group.contains("SNAPSHOT")) {
                System.out.println("************************************************************************************************************************************");
                System.out.println("************************************************************************************************************************************");
                System.out.println(projectName);
                print(group);
            }
        }
    }

    public static void print(String de) {
        System.out.println(de.replaceAll(" +", "\r\n"));
    }
}
