package com.msl.java;

import com.google.common.collect.Lists;
import com.msl.FileContext;
import com.msl.NormalUpdater;
import org.javatuples.Pair;

import java.util.List;

/**
 * @author wanglq
 * Date 2024/9/9
 * Time 17:08
 */
public class JavaEsUpdater extends NormalUpdater {
    static List<Pair<String, String>> replaceList = Lists.newArrayList();
    static List<Pair<String, String>> replaceAllList = Lists.newArrayList();

    static {
        replaceList.add(Pair.with("import org.springframework.data.elasticsearch.annotations.*;",
                "import org.dromara.easyes.annotation.*;\r\nimport org.dromara.easyes.annotation.rely.FieldType;"));
        replaceList.add(Pair.with("@Document(indexName = \"", "@IndexName(value = \""));
        replaceList.add(Pair.with("@Field(type = FieldType.Integer)", "@IndexField(fieldType = FieldType.INTEGER)"));
        replaceList.add(Pair.with("@Field(type = FieldType.Long)", "@IndexField(fieldType = FieldType.LONG)"));
        replaceList.add(Pair.with("@Field(type = FieldType.Double)", "@IndexField(fieldType = FieldType.DOUBLE)"));
        replaceList.add(Pair.with("@Field(type = FieldType.Text)", "@IndexField(fieldType = FieldType.TEXT)"));
        replaceList.add(Pair.with("@Field(type = FieldType.Date, format = {}, pattern = LocalDateTimeUtils.DATETIME_FORMATTER)",
                "@IndexField(fieldType = FieldType.DATE, dateFormat = LocalDateTimeUtils.DATETIME_FORMATTER)"));

        replaceAllList.add(Pair.with("@MultiField.+\\r\\n.+\\r\\n.+\\)", "@IndexField(fieldType = FieldType.KEYWORD_TEXT)"));
    }

    @Override
    protected List<Pair<String, String>> replaceList() {
        return replaceList;
    }

    /**
     * 更新文件上下文
     *
     * @param context 文件上下文
     */
    @Override
    public void update(FileContext context) {
        super.update(context);
        String content = context.getContent();
        for (Pair<String, String> pair : replaceAllList) {
            content = content.replaceAll(pair.getValue0(), pair.getValue1());
        }
        context.setContent(content);

    }

    /**
     * 能否更新文件
     *
     * @param context 文件上下文
     * @return 能否更新
     */
    @Override
    public boolean canApply(FileContext context) {
        return context.getFileName().endsWith(".java");
    }
}
